Subject: Re: linux-next: manual merge of the akpm-current tree with the dma-mapping tree

From: Andrew Morton <[email-masked]>
Date: Tue, 28 Oct 2014 13:26:17 -0700

On Tue, 28 Oct 2014 07:54:09 +0100 Marek Szyprowski <[email-masked]> wrote:

> Hello,
> 
> On 2014-10-28 07:29, Andrew Morton wrote:
> > On Tue, 28 Oct 2014 15:24:44 +1100 Stephen Rothwell <[email-masked]> wrote:
> >
> >> Today's linux-next merge of the akpm-current tree got a conflict in
> >> mm/cma.c between commit 16195ddd4ebc ("mm: cma: Ensure that
> >> reservations never cross the low/high mem boundary") from the
> >> dma-mapping tree and commit 2a70e5a78672 ("mm/cma: ake kmemleak ignore
> >> CMA regions") from the akpm-current tree.
> > hm, we have multiple trees altering mm/cma.c?
> >
> > I'm a bit surprised that this series was merged, given that Laurent
> > said he would be sending out a v2...
> 
> v2 of Laurent's patches has been posted on 24th October
> (https://lkml.org/lkml/2014/10/24/207 ), but since I didn't notice them 
> to be taken
> I thought that it would make sense to get them via my tree and send them 
> to Linus
> during the 3.18-rc cycle. If this was not appropriate, I will drop my tree.

I think I got it all sorted out.  Thierry's "mm/cma: make kmemleak
ignore CMA regions" needed a bit of rework - please check.

From: Thierry Reding <[email-masked]>
Subject: mm/cma: make kmemleak ignore CMA regions

kmemleak will add allocations as objects to a pool.  The memory allocated
for each object in this pool is periodically searched for pointers to
other allocated objects.  This only works for memory that is mapped into
the kernel's virtual address space, which happens not to be the case for
most CMA regions.  

Furthermore, CMA regions are typically used to store data transferred to
or from a device and therefore don't contain pointers to other objects.

Without this, the kernel crashes on the first execution of the
scan_gray_list() because it tries to access highmem.  Perhaps a more
appropriate fix would be to reject any object that can't map to a kernel
virtual address?

[[email-masked]: add comment]
[[email-masked]: fix comment, per Catalin]
[[email-masked]: include linux/io.h for phys_to_virt()]
Signed-off-by: Thierry Reding <[email-masked]>
Cc: Michal Nazarewicz <[email-masked]>
Cc: Marek Szyprowski <[email-masked]>
Cc: Joonsoo Kim <[email-masked]>
Cc: "Aneesh Kumar K.V" <[email-masked]>
Cc: Catalin Marinas <[email-masked]>
Signed-off-by: Stephen Rothwell <[email-masked]>
Signed-off-by: Andrew Morton <[email-masked]>
---

 mm/cma.c |    6 ++++++
 1 file changed, 6 insertions(+)

diff -puN mm/cma.c~mm-cma-make-kmemleak-ignore-cma-regions mm/cma.c
--- a/mm/cma.c~mm-cma-make-kmemleak-ignore-cma-regions
+++ a/mm/cma.c
@@ -33,6 +33,7 @@
 #include <linux/log2.h>
 #include <linux/cma.h>
 #include <linux/highmem.h>
+#include <linux/io.h>
 
 struct cma {
 	unsigned long	base_pfn;
@@ -301,6 +302,11 @@ int __init cma_declare_contiguous(phys_a
 			}
 		}
 
+		/*
+		 * kmemleak scans/reads tracked objects for pointers to other
+		 * objects but this address isn't mapped and accessible
+		 */
+		kmemleak_ignore(phys_to_virt(addr));
 		base = addr;
 	}
 
_